
function train_candbbs = load_candidate_boxes(index, mask)
  train_candbbs = struct;
  train_imi = find(mask);
  


  if exist('data/masks/bbs.mat', 'file')
    load('data/masks/bbs.mat');
  else
    boxes = [];
  end
  
  for outi = 1:length(train_imi)      
    imi = train_imi(outi);
    imsize = index.imsizes(imi, :);
    fprintf('Loading candidate boxes: %d/%d\r', outi, length(train_imi));
    train_candbbs(outi).orgimi = imi;
    % candidate boxes           
    if isempty(boxes)
      masks = load(['data/masks/' index.imnames{imi} '.mat']);
      train_candbbs(outi).bbuint8 = bbs_to_uint8(masks.bbs, imsize);
    else 
      train_candbbs(outi).bbuint8 = bbs_to_uint8(boxes(imi).bbs, imsize);
    end

  end
  
end  

    

function bbs_uint8 = bbs_to_uint8(bbs, imsize)
  % rescale image bboxes to encode them in uint8 and save some space
  
  bbs = double(bbs);
  xscale = 255 / (imsize(2) - 1);
  yscale = 255 / (imsize(1) - 1);
  scales = [xscale yscale xscale yscale];
  bbs = bsxfun(@plus, bsxfun(@times, bbs, scales), -scales);
  bbs_uint8 = uint8(bbs);
  
end
