#pragma once
#include "cn_os.hpp"

/**
 * Author: R. Gokberk Cinbis.
 */


// DONT : #include "cn_os.hpp"

// TOSTR() converts any given macro of value val to "val". TOSTR2 is just a helper function.
// (stringification)
#define TOSTR2(arg) #arg
#define TOSTR(arg)  TOSTR2(arg)

// TODO: DISABME MAX,MIN COMPLETELY. THESE ARE EVIL ESPECIALLY FOR THINGS LIKE MAX(x[*(ptr++)],y)

#ifndef MIN
#define MIN(X,Y) ((X) < (Y) ? (X) : (Y))
#endif

#ifndef MAX
#define MAX(X,Y) ((X) > (Y) ? (X) : (Y))
#endif

// These are all correct for positive numbers but dont define the macro. 
// It is best to choose the version specific for the usage.
//
//#ifndef CEILPOSINTDIV
//#define CEILPOSINTDIV(X,Y) ((X) + (Y) - 1) / (Y) // positive numbers only + may overflow
//#define CEILPOSINTDIV(X,Y) (((X)-1) / (Y) + 1) // positive numbers only 
//#define CEILPOSINTDIV(X,Y) ((X) % (Y)) ? ((X) / (Y) + 1) : ((X) / (Y)) // positive numbers only
//#endif

#ifdef TMPDIR0
#define TMPDIR      TOSTR(TMPDIR0)
#endif


#ifdef CN_LINUX
#define SHMDIR      TOSTR(/dev/shm/USERNAME/)
#elif defined( CN_WINDOWS )
#define SHMDIR      TMPDIR 
#else
#error Unknown platform
#endif


