
/**
 * Author: R. Gokberk Cinbis.
 */


#if defined(POOL_BOXES)

    #define HAS_PT_WEIGHTS 0
    if ( !bbs )
        throw runtime_error("poolbox requires bbs");

#elif defined(POOL_BOXES_WITH_PTWEIGHTS)

    #define HAS_PT_WEIGHTS 1

#elif defined(POOL_TREE)

    #define HAS_PT_WEIGHTS 0
    if (masktype!=MaskNone)
        throw runtime_error("Only masktype=MaskNone is supported for pooltrees");
    if ( minscs!=NULL || maxscs!=NULL ) 
        throw runtime_error("pooltree does not support scales");

#else
#error Unknown case
#endif

#if HAS_PT_WEIGHTS
    #define mask_t float
    if ( (masktype != MaskFloat) && (masktype != MaskImage) )
        throw runtime_error("bug: HAS_PT_WEIGHTS=1 requires MaskFloat or MaskImage");
#else
    #define mask_t bool
    if ( (masktype != MaskNone) && (masktype!=MaskBool) && (masktype!=MaskBackground) )
        throw runtime_error("bug: HAS_PT_WEIGHTS=0 requires MaskNone or MaskBool or MaskBackground");
#endif

if (masktype==MaskNone) {
    // ok.
} else if (masktype==MaskBool) {
    if ( !masks_bool )
        throw runtime_error("bug: masktype is invalid");
} else if (masktype==MaskFloat) {
    if ( !masks_float )
        throw runtime_error("bug: masktype is invalid");
} else if (masktype==MaskImage) {
    if ( !maskim || !maskind )
        throw runtime_error("bug: masktype is invalid");
} else {
    throw runtime_error("unknown masktype in poolobjdesc_init.hpp");
}


