function out = cn_fvgmm_reshape(op,data,D,K)
% Permute/convert Fv MoG data from one data ordering to another efficiently.
%
% USAGE
% out = cn_fvgmm_reshape('kmajor->stacked',data,D,K)
%   data    ((1+D*2) K R)   Each data(:,k,r) is the fisher vector w.r.t. [mix_k; mu_k; prec_k]
%   D       (1 1)           Descriptor length.
%   K       (1 1)           Vocabulary size.
%   out     (K*(1+D*2) R)   Each data(:,r) is the fisher vector concatenated of [fv_mix(:); fv_mu(:); fv_prec(:)]
%                           [reshape(data(1,:,:),[K R]); reshape(data(2:1+D,:,:),[D*K R]); reshape(data(2+D:1+2*D,:,:),[D*K R])]; 
%                           
% R.Gokberk Cinbis

error('compile cn_fvgmm_reshape');

