function im = cn_im2double(im)
% Convert a given non-indexed image into flat.
% Equivalent to im2double of matlab. 
%
% INPUT
% im        Image of some numeric/logical type.
% 
% OUTPUT
% im
%
% R.G.Cinbis, Oct'11

c = class(im);

switch(c)
    case 'double'
        % ok.
    case 'single'
        im = double(im);
    case 'logical'
        im = double(im);
    case {'uint8','uint16'}
        u = double(intmax(c)); % positive
        im = double(im) / u;
    case 'int16'
        l = double(intmin(c)); % negative
        u = double(intmax(c)); % positive
        im = (double(im) - l) / (u - l);
    otherwise
        error('unsupported input image');
end

assert(isa(im,'double'));


