function out_x1y1x2y2 = cn_mappts_applytobb(bb_x1y1x2y2,mapinfo)
% out_x1y1x2y2 = cn_mappts_applytobb(bb_x1y1x2y2,mapinfo)
%
% Similar to cn_mappts_apply() but processes bounding boxes.
% Output is in double.
%
% bb_x1y1x2y2  #bb x 4  or #bb x 4 x nref
%                           
% R.Gokberk Cinbis

bb_x1y1x2y2 = double(bb_x1y1x2y2);

if isempty(bb_x1y1x2y2)
    out_x1y1x2y2 = bb_x1y1x2y2;
    return;
end

sz = size(bb_x1y1x2y2);
assert(sz(2)==4);
assert(length(sz)==2);
n = sz(1);

scale1 = mapinfo.scale1; % (2 1 nref)
shift2 = mapinfo.shift2; % (2 1 nref)
nref = size(scale1,3);

% much faster
scale1 = reshape(scale1,[1 2 nref]); scale1 = [scale1 scale1];
shift2 = reshape(shift2,[1 2 nref]); shift2 = [shift2 shift2];
out_x1y1x2y2 = bsxfun(@plus,bsxfun(@times,bb_x1y1x2y2,scale1),shift2);

%{
% reference
tmp = [bb_x1y1x2y2(:,1).' bb_x1y1x2y2(:,3).'; bb_x1y1x2y2(:,2).' bb_x1y1x2y2(:,4).'];
P = cn_mappts_apply(tmp,mapinfo);
out2 = [P(1,1:n).' P(2,1:n).' P(1,(n+1):end).' P(2,(n+1):end).'];
assert(isequal(out_x1y1x2y2,out2)); mywarn('cn_mappts_applytobb:OK');
%}



