function mask = cn_randmask(n,k)
% Creates a (1 n) logical array with k true elements.
% 
% INPUT
% n     A scalar.
% k     A scalar.
% 
% OUTPUT
% mask  (1 n)
%
% SEE cn_randsubset
% 
% R. Gokberk Cinbis, July 2011

if k==n
    mask = true(1,n);
    return;
end

assert(k<=n,'k<=n assertion has failed');

mask = false(1,n);
i = randperm(n);        % new randperm implementations support generating only k numbers but I don't use it here for repeatability of old experiments.
mask(i(1:k)) = true;


