function out = cn_gaussdiag_pb(XT,info,opt)
% Returns log-joint probabilities and posterior probabilities for
% gaussian distributions (ie GMM) with diagonal covariances.
%
% INPUT
% XT    (D N)
% info  See cn_gaussdiag_precalc()
% opt   See "opt" in cn_getmixmodelpbs()
% 
% OUTPUT
% out   See "out" in cn_getmixmodelpbs()
%
% R.G.Cinbis July 2011.

N = size(XT,2); 

% -- old slower (used to be much slower) --
%logcond = -0.5 * reshape( cn_pdist2(struct2('XT',XT,'YT',info.mu,...
%    'distance','YTWsqeuclidean'),struct2('YTW',info.precs)), N, info.K); % (N K)

% todo: can we *efficiently* avoid intermediate matrix XT.^2?
logcond = (XT.^2).'*info.w_x2; % -.5 * sum_d( w_d * x_d^2 )
logcond = logcond + XT.'*info.w_x; % +=  sum_d( w_d * mu_d * x_d )
logcond = bsxfun(@plus,logcond,info.bias);

% -- old --
% logcond = bsxfun(@plus,logcond,info.nh_spmu2); % += -.5 * sum_d( w_d * mu_d^2 )
% logcond = bsxfun(@plus,logcond,info.normconst);

out = cn_getmixmodelpbs(struct2('logcond',logcond,'logprior',info.logprior),opt);


