function result = cn_isdesktop()
% result = cn_isdesktop()
%
% Returns true if matlab desktop environment is running, otherwise,
% returns false. Efficient to call multiple times.
%
% R.G.Cinbis May 2011

persistent p

if isempty(p)
    p = true;
    try 
        a = javachk('desktop');
        if isempty(a)
            p = true;
        else
            p = false;
        end
    catch e
        p = false;
    end
end

result = p;

mlock

